include     c:\masm32\include\masm32rt.inc
; 

DumpArray PROTO :DWORD

.data?

    pMem        dd  ?
    cByt        dd  ?
    msecs       dd  ?
    primesfound dd  ?
    
.data

    startmsg    db  13,10,"Primzahlen nach dem Sieb des Eratosthenes berechnen, bis: ",0
; 

.code
start:
    print addr startmsg
    mov cByt,val(input())
    .if cByt==0
        mov cByt,500000
    .endif

    invoke GlobalAlloc,GMEM_FIXED,cByt
    mov pMem,eax
    .if eax==NULL
        print "Nicht genug Speicher!",13,10
        exit
    .endif
;---------------------------------------------------------------
    print "Sieben bis "
    print ustr$(cByt), " . . ."
;---------------------------------------------------------------
; Bytearray initialisieren
;---------------------------------------------------------------
    mov edx,0
    mov esi,pMem
    .repeat
        mov byte ptr[esi+edx],0
        add edx,1
    .until edx==cByt
    invoke GetTickCount
    mov msecs,eax
align 4
@@:
    invoke GetTickCount
    .if msecs==eax
        jmp @B
    .endif
    mov msecs,eax
;---------------------------------------------------------------
; Sieve - translated from PSEUDO to ASM
;---------------------------------------------------------------
    mov ebx,2                               ; ebx = i
    mov eax,2
    mul eax                                 ; eax = i*i
align 4
    .while eax < cByt                       ; while i*i < N
        .if byte ptr[esi+ebx]==0            ;   if not gestrichen[i] then
            mov edx,eax                     ;     ebx = j
            .while edx < cByt               ;     for j = i*i to N
                mov byte ptr[esi+edx],1     ;        gestrichen[j] = true
                add edx,ebx
            .endw
        .endif
        inc ebx                             ; i = i+1
        mov eax,ebx
        mul eax                             ; eax = i*i
    .endw
    invoke DumpArray,esi    ; process bytearray, inc primesfound for every
                            ; number that is not 'gestrichen' (deleted)
   
    invoke GlobalFree,pMem
    .if eax!=NULL
        print "ERROR GlobalFree "
    .endif
    exit
;---------------------------------------------------------------
align 4
DumpArray proc pArr:DWORD
        
    mov esi,pArr
    mov ebx,1
    mov primesfound,0
align 4
    .while ebx < cByt
        .if byte ptr[esi+ebx]==0
            ;print str$(ebx),9
            inc primesfound
        .endif
        add ebx,2
    .endw
    invoke GetTickCount
    sub eax,msecs
    mov msecs,eax
    
    print chr$(13,10,13,10)
    print " Bis "
    print ustr$(cByt)," wurden "
    print ustr$(primesfound)," Primzahlen gefunden in "
    print ustr$(msecs)," ms."
    
    ret
DumpArray endp    
end start